> ## Documentation Index
> Fetch the complete documentation index at: https://developers.avacloud.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List asset transactions

> Lists asset transactions corresponding to the given asset id on the X-Chain.



## OpenAPI

````yaml get /v1/networks/{network}/blockchains/{blockchainId}/assets/{assetId}/transactions
openapi: 3.1.0
info:
  title: Data API
  description: >-
    The Data API provides web3 application developers with multi-chain data
    related to Avalanche's primary network, Avalanche subnets, and Ethereum.
    With Data API, you can easily build products that leverage real-time and
    historical transaction and transfer history, native and token balances, and
    various types of token metadata. The API is in Beta and may be subject to
    change.</br></br>If you have feedback or feature requests for the API,
    please submit them <a
    href="https://portal.productboard.com/dndv9ahlkdfye4opdm8ksafi/tabs/4-glacier-api">here</a>.
    Bug reports can be submitted <a
    href="https://docs.google.com/forms/d/e/1FAIpQLSeJQrcp7QoNiqozMDKrVJGX5wpU827d3cVTgF8qa7t_J1Pb-g/viewform">here</a>,
    and any potential security issues can be reported <a
    href="https://immunefi.com/bounty/avalabs">here</a>.
  version: 1.0.0
  contact: {}
servers:
  - url: https://glacier-api.avax.network
security:
  - apiKey: []
  - {}
tags:
  - name: EVM Chains
    description: >-
      Find information about indexed EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Blocks
    description: >-
      Find information about blocks on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Transactions
    description: >-
      Find information about transactions on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Balances
    description: >-
      Find information about balances on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Contracts
    description: >-
      Find information about contracts on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: Primary Network
  - name: Primary Network Blocks
    description: >-
      Find information about blocks on Avalanche's Primary Network Chains - the
      P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network Vertices
    description: Find information about vertices on Avalanche's X-Chain.
  - name: Primary Network Transactions
    description: >-
      Find information about transactions on Avalanche's Primary Network Chains
      - the P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network Balances
    description: >-
      Find information about balances on Avalanche's Primary Network Chains -
      the P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network UTXOs
    description: >-
      Find information about utxos on Avalanche's Primary Network Chains - the
      P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network Rewards
    description: Find information about rewards on Avalanche's Primary Network.
  - name: NFTs
  - name: Operations
  - name: Health Check
  - name: Teleporter
    description: Find information about Teleporter transactions.
  - name: Interchain Messaging
    description: Find information about Interchain Messaging transactions.
  - name: Webhooks
    description: Manage webhooks and get notified for various onchain activities.
  - name: RPC
    description: Interact with chain nodes using JSON-RPC.
  - name: Data API Usage Metrics
    description: Usage metrics and logs for the Data API.
  - name: Signature Aggregator
    description: Request signatures for a Warp message from Subnet validators
  - name: Notifications
    description: Get notifications for validator status and activity issues.
  - name: AVAX Supply
    description: Find information about AVAX supply.
paths:
  /v1/networks/{network}/blockchains/{blockchainId}/assets/{assetId}/transactions:
    get:
      tags:
        - Primary Network Transactions
      summary: List asset transactions
      description: >-
        Lists asset transactions corresponding to the given asset id on the
        X-Chain.
      operationId: listAssetTransactions
      parameters:
        - name: txTypes
          required: false
          in: query
          example:
            - AddValidatorTx
          description: Query param for filtering items based on transaction types.
          schema:
            type: array
            items:
              $ref: '#/components/schemas/PrimaryNetworkTxType'
        - name: startTimestamp
          required: false
          in: query
          description: Query param for retrieving items after a specific timestamp.
          example: 1689541049
          schema:
            minimum: 0
            type: integer
        - name: endTimestamp
          required: false
          in: query
          description: Query param for retrieving items before a specific timestamp.
          example: 1689800249
          schema:
            minimum: 0
            type: integer
        - name: pageToken
          required: false
          in: query
          description: >-
            A page token, received from a previous list call. Provide this to
            retrieve the subsequent page.
          schema:
            type: string
        - name: pageSize
          required: false
          in: query
          description: >-
            The maximum number of items to return. The minimum page size is 1.
            The maximum pageSize is 100.
          schema:
            type: integer
            default: 10
            minimum: 1
            maximum: 100
          example: '10'
        - name: blockchainId
          required: true
          in: path
          description: A primary network blockchain id or alias.
          example: x-chain
          schema:
            $ref: '#/components/schemas/XChainId'
        - name: network
          required: true
          in: path
          description: Either mainnet or testnet/fuji.
          example: mainnet
          schema:
            $ref: '#/components/schemas/Network'
        - name: assetId
          required: true
          in: path
          description: Asset ID for any asset on X-Chain
          example: th5aLdWLi32yS9ED6uLGoMMubqHjzMsXhKWwzP6yZTYQKYzof
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListXChainTransactionsResponse'
        '400':
          description: |-
            Bad requests generally mean the client has passed invalid 
                or malformed parameters. Error messages in the response could help in 
                evaluating the error.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequest'
        '401':
          description: |-
            When a client attempts to access resources that require 
                authorization credentials but the client lacks proper authentication 
                in the request, the server responds with 401.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Unauthorized'
        '403':
          description: |-
            When a client attempts to access resources with valid
                credentials but doesn't have the privilege to perform that action, 
                the server responds with 403.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Forbidden'
        '404':
          description: |-
            The error is mostly returned when the client requests
                with either mistyped URL, or the passed resource is moved or deleted, 
                or the resource doesn't exist.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFound'
        '429':
          description: |-
            This error is returned when the client has sent too many,
                and has hit the rate limit.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TooManyRequests'
        '500':
          description: |-
            The error is a generic server side error that is 
                returned for any uncaught and unexpected issues on the server side. 
                This should be very rare, and you may reach out to us if the problem 
                persists for a longer duration.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InternalServerError'
        '502':
          description: |-
            This is an internal error indicating invalid response 
                  received by the client-facing proxy or gateway from the upstream server.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadGateway'
        '503':
          description: |-
            The error is returned for certain routes on a particular
                Subnet. This indicates an internal problem with our Subnet node, and may 
                not necessarily mean the Subnet is down or affected.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ServiceUnavailable'
      x-codeSamples:
        - lang: javascript
          label: JavaScript
          source: |-
            import { Avalanche } from "@avalanche-sdk/chainkit";

            const avalanche = new Avalanche({
              network: "mainnet",
            });

            async function run() {
              const result = await avalanche.data.primaryNetwork.transactions.listAssetTransactions({
                txTypes: [
                  "AddValidatorTx",
                ],
                startTimestamp: 1689541049,
                endTimestamp: 1689800249,
                pageSize: 10,
                blockchainId: "x-chain",
                assetId: "th5aLdWLi32yS9ED6uLGoMMubqHjzMsXhKWwzP6yZTYQKYzof",
              });

              for await (const page of result) {
                console.log(page);
              }
            }

            run();
components:
  schemas:
    PrimaryNetworkTxType:
      type: string
      enum:
        - AddValidatorTx
        - AddSubnetValidatorTx
        - AddDelegatorTx
        - CreateChainTx
        - CreateSubnetTx
        - ImportTx
        - ExportTx
        - AdvanceTimeTx
        - RewardValidatorTx
        - RemoveSubnetValidatorTx
        - TransformSubnetTx
        - AddPermissionlessValidatorTx
        - AddPermissionlessDelegatorTx
        - BaseTx
        - TransferSubnetOwnershipTx
        - ConvertSubnetToL1Tx
        - RegisterL1ValidatorTx
        - SetL1ValidatorWeightTx
        - DisableL1ValidatorTx
        - IncreaseL1ValidatorBalanceTx
        - UNKNOWN
        - CreateAssetTx
        - OperationTx
    XChainId:
      type: string
      enum:
        - 2oYMBNV4eNHyqk2fjjV5nVQLDbtmNJzq5s3qs3Lo6ftnC6FByM
        - 2JVSBoinj9C2J33VntvzYtVJNZdN2NKiwwKjcumHUWEb5DbBrm
        - x-chain
    Network:
      type: string
      enum:
        - mainnet
        - fuji
        - testnet
    ListXChainTransactionsResponse:
      type: object
      properties:
        nextPageToken:
          type: string
          description: >-
            A token, which can be sent as `pageToken` to retrieve the next page.
            If this field is omitted or empty, there are no subsequent pages.
        transactions:
          type: array
          items:
            anyOf:
              - $ref: '#/components/schemas/XChainNonLinearTransaction'
              - $ref: '#/components/schemas/XChainLinearTransaction'
        chainInfo:
          $ref: '#/components/schemas/PrimaryNetworkChainInfo'
      required:
        - transactions
        - chainInfo
    BadRequest:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 400
        error:
          type: string
          description: The type of error
          examples:
            - Bad Request
      required:
        - message
        - statusCode
        - error
    Unauthorized:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 401
        error:
          type: string
          description: The type of error
          examples:
            - Unauthorized
      required:
        - message
        - statusCode
        - error
    Forbidden:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 403
        error:
          type: string
          description: The type of error
          examples:
            - Forbidden
      required:
        - message
        - statusCode
        - error
    NotFound:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 404
        error:
          type: string
          description: The type of error
          examples:
            - Not Found
      required:
        - message
        - statusCode
        - error
    TooManyRequests:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 429
        error:
          type: string
          description: The type of error
          examples:
            - Too Many Requests
      required:
        - message
        - statusCode
        - error
    InternalServerError:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 500
        error:
          type: string
          description: The type of error
          examples:
            - Internal Server Error
      required:
        - message
        - statusCode
        - error
    BadGateway:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 502
        error:
          type: string
          description: The type of error
          examples:
            - Bad Gateway
      required:
        - message
        - statusCode
        - error
    ServiceUnavailable:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 503
        error:
          type: string
          description: The type of error
          examples:
            - Service Unavailable
      required:
        - message
        - statusCode
        - error
    XChainNonLinearTransaction:
      type: object
      properties:
        txHash:
          type: string
          description: Unique ID for this transaction.
          examples:
            - 3j9JpF1aGuQtLLbo3YkvvKkWrCZViXZjdeJQWUSEY5hcqUn2c
        chainFormat:
          type: string
          description: Represents chain format this transaction is included in.
          enum:
            - non-linear
            - linear
          examples:
            - non-linear
        timestamp:
          type: number
          description: >-
            Latest timestamp in seconds this transaction was accepted out of the
            same transaction accepted in other vertices.
          examples:
            - 1600762738
        txType:
          $ref: '#/components/schemas/XChainTransactionType'
          examples:
            - BaseTx
        memo:
          type: string
          description: Hex encoded memo bytes for this transaction.
          examples:
            - '0x546865204176616c616e6368652050726f6a656374'
        consumedUtxos:
          type: array
          items:
            $ref: '#/components/schemas/Utxo'
        emittedUtxos:
          type: array
          items:
            $ref: '#/components/schemas/Utxo'
        amountUnlocked:
          description: Assets unlocked by inputs of this transaction.
          type: array
          items:
            $ref: '#/components/schemas/AssetAmount'
        amountCreated:
          description: Assets created by outputs of this transaction.
          type: array
          items:
            $ref: '#/components/schemas/AssetAmount'
        sourceChain:
          type: string
          description: Source chain for an atomic transaction.
          examples:
            - 2oYMBNV4eNHyqk2fjjV5nVQLDbtmNJzq5s3qs3Lo6ftnC6FByM
        destinationChain:
          type: string
          description: Destination chain for an atomic transaction.
          examples:
            - 2oYMBNV4eNHyqk2fjjV5nVQLDbtmNJzq5s3qs3Lo6ftnC6FByM
        assetCreated:
          description: AssetAmount details of the asset created in CreateAssetTx
          allOf:
            - $ref: '#/components/schemas/XChainAssetDetails'
        vertices:
          description: A transaction on X-Chain can be accepted over multiple vertices.
          type: array
          items:
            $ref: '#/components/schemas/TransactionVertexDetail'
      required:
        - txHash
        - chainFormat
        - timestamp
        - txType
        - memo
        - consumedUtxos
        - emittedUtxos
        - amountUnlocked
        - amountCreated
        - vertices
    XChainLinearTransaction:
      type: object
      properties:
        txHash:
          type: string
          description: Unique ID for this transaction.
          examples:
            - 3j9JpF1aGuQtLLbo3YkvvKkWrCZViXZjdeJQWUSEY5hcqUn2c
        chainFormat:
          type: string
          description: Represents chain format this transaction is included in.
          enum:
            - non-linear
            - linear
          examples:
            - non-linear
        timestamp:
          type: number
          description: >-
            Latest timestamp in seconds this transaction was accepted out of the
            same transaction accepted in other vertices.
          examples:
            - 1600762738
        txType:
          $ref: '#/components/schemas/XChainTransactionType'
          examples:
            - BaseTx
        memo:
          type: string
          description: Hex encoded memo bytes for this transaction.
          examples:
            - '0x546865204176616c616e6368652050726f6a656374'
        consumedUtxos:
          type: array
          items:
            $ref: '#/components/schemas/Utxo'
        emittedUtxos:
          type: array
          items:
            $ref: '#/components/schemas/Utxo'
        amountUnlocked:
          description: Assets unlocked by inputs of this transaction.
          type: array
          items:
            $ref: '#/components/schemas/AssetAmount'
        amountCreated:
          description: Assets created by outputs of this transaction.
          type: array
          items:
            $ref: '#/components/schemas/AssetAmount'
        sourceChain:
          type: string
          description: Source chain for an atomic transaction.
          examples:
            - 2oYMBNV4eNHyqk2fjjV5nVQLDbtmNJzq5s3qs3Lo6ftnC6FByM
        destinationChain:
          type: string
          description: Destination chain for an atomic transaction.
          examples:
            - 2oYMBNV4eNHyqk2fjjV5nVQLDbtmNJzq5s3qs3Lo6ftnC6FByM
        assetCreated:
          description: AssetAmount details of the asset created in CreateAssetTx
          allOf:
            - $ref: '#/components/schemas/XChainAssetDetails'
        blockHeight:
          type: number
          description: Height of the block this transaction belongs to.
          examples:
            - 1005
        blockHash:
          type: string
          description: Hash of the block this transaction belongs to.
          examples:
            - 82qPRREHmh8Cfta4PGD6GymY9ZLyvgYugqW6hj9FykpMVRz1S
      required:
        - txHash
        - chainFormat
        - timestamp
        - txType
        - memo
        - consumedUtxos
        - emittedUtxos
        - amountUnlocked
        - amountCreated
        - blockHeight
        - blockHash
    PrimaryNetworkChainInfo:
      type: object
      properties:
        chainName:
          $ref: '#/components/schemas/PrimaryNetworkChainName'
        network:
          $ref: '#/components/schemas/Network'
      required:
        - chainName
        - network
    XChainTransactionType:
      type: string
      description: Type of transaction.
      enum:
        - BaseTx
        - CreateAssetTx
        - OperationTx
        - ImportTx
        - ExportTx
        - UNKNOWN
    Utxo:
      type: object
      properties:
        addresses:
          description: Addresses that are eligible to sign the consumption of this output.
          examples:
            - - avax1qm2a25eytsrj235hxg6jc0mwk99tss64eqevsw
          type: array
          items:
            type: string
        asset:
          $ref: '#/components/schemas/AssetAmount'
        consumedOnChainId:
          type: string
          description: Blockchain ID on which this output is consumed on.
          examples:
            - 2oYMBNV4eNHyqk2fjjV5nVQLDbtmNJzq5s3qs3Lo6ftnC6FByM
        consumingTxHash:
          type: string
          description: Transaction ID that consumed this output.
          examples:
            - 3j9JpF1aGuQtLLbo3YkvvKkWrCZViXZjdeJQWUSEY5hcqUn2c
        createdOnChainId:
          type: string
          description: Blockchain ID on which this output is created on.
          examples:
            - 2oYMBNV4eNHyqk2fjjV5nVQLDbtmNJzq5s3qs3Lo6ftnC6FByM
        utxoId:
          type: string
          description: UTXO ID for this output.
          examples:
            - 68vLva9kfKUsX88ZPM8jdbf8qHUZRoZSFH6NdpAVTspkfrXDC
        utxoBytes:
          type: string
          description: The bytes of the UTXO
        consumingTxTimestamp:
          type: number
          description: Unix timestamp in seconds at which this output was consumed.
          examples:
            - 1599696000
        creationTxHash:
          type: string
          description: Transaction ID that created this output.
          examples:
            - FvwEAhmxKfeiG8SnEvq42hc6whRyY3EFYAvebMqDNDGCgxN5Z
        credentials:
          description: Credentials that signed the transaction to consume this utxo
          type: array
          items:
            $ref: '#/components/schemas/UtxoCredential'
        groupId:
          type: number
          description: Index representing the minting set for the NFT mint output.
        locktime:
          type: number
          description: Locktime in seconds after which this output can be consumed.
          examples:
            - 0
        outputIndex:
          type: string
          description: >-
            Postion of this output in a list of lexiographically sorted outputs
            of a transaction.
          examples:
            - '38'
        payload:
          type: string
          description: Hex encoded data for NFT assets.
        threshold:
          type: number
          description: Minimum number of signatures required to consume this output.
          examples:
            - 1
        timestamp:
          type: number
          description: Unix timestamp in seconds at which this outptut was created.
          examples:
            - 1599696000
        utxoType:
          type: string
          description: Type of output.
          examples:
            - mint
      required:
        - addresses
        - asset
        - consumedOnChainId
        - createdOnChainId
        - utxoId
        - creationTxHash
        - locktime
        - outputIndex
        - threshold
        - timestamp
        - utxoType
    AssetAmount:
      type: object
      properties:
        assetId:
          type: string
          description: Unique ID for an asset.
          examples:
            - th5aLdWLi32yS9ED6uLGoMMubqHjzMsXhKWwzP6yZTYQKYzof
        name:
          type: string
          description: Name of this asset.
          examples:
            - Avalanche
        symbol:
          type: string
          description: Symbol for this asset (max 4 characters).
          examples:
            - AVAX
        denomination:
          type: number
          description: Denomination of this asset to represent fungibility.
          examples:
            - 9
        type:
          $ref: '#/components/schemas/PrimaryNetworkAssetType'
          examples:
            - secp256k1
        amount:
          type: string
          description: Amount of the asset.
          examples:
            - '5001000'
      required:
        - assetId
        - name
        - symbol
        - denomination
        - type
        - amount
    XChainAssetDetails:
      type: object
      properties:
        assetId:
          type: string
          description: Unique ID for an asset.
          examples:
            - th5aLdWLi32yS9ED6uLGoMMubqHjzMsXhKWwzP6yZTYQKYzof
        name:
          type: string
          description: Name of this asset.
          examples:
            - Avalanche
        symbol:
          type: string
          description: Symbol for this asset (max 4 characters).
          examples:
            - AVAX
        denomination:
          type: number
          description: Denomination of this asset to represent fungibility.
          examples:
            - 9
        type:
          $ref: '#/components/schemas/PrimaryNetworkAssetType'
          examples:
            - secp256k1
        createdAtTimestamp:
          type: number
          description: Timestamp in seconds this asset was created on.
          examples:
            - 1675444720
        cap:
          $ref: '#/components/schemas/PrimaryNetworkAssetCap'
          examples:
            - fixed
      required:
        - assetId
        - name
        - symbol
        - denomination
        - type
        - createdAtTimestamp
        - cap
    TransactionVertexDetail:
      type: object
      properties:
        hash:
          type: string
          description: Vertex ID of the vertex this transaction belongs to.
          examples:
            - 82qPRREHmh8Cfta4PGD6GymY9ZLyvgYugqW6hj9FykpMVRz1S
        height:
          type: number
          description: Vertex height of the vertex this transaction belongs to.
          examples:
            - 1961
        timestamp:
          type: number
          description: Timestamp in seconds this vertex was accepted.
          examples:
            - 1600762738
      required:
        - hash
        - height
        - timestamp
    PrimaryNetworkChainName:
      type: string
      enum:
        - p-chain
        - x-chain
        - c-chain
    UtxoCredential:
      type: object
      properties:
        signature:
          type: string
          description: Signature provided to consume the output.
          examples:
            - >-
              bWWoZUu0Z3STjuk/+2az7M4vP0oqc9NtiA7kOdqINCIE/2+5va5R1KNCWwEX5jE1xVHLvAxU2LHTN5gK8m84HwA
        publicKey:
          type: string
          description: Public key associated with the signature.
          examples:
            - AdMQOtubgBFFJu++0faHPIIA6KmdZ2ERErMRGzyy6juI
    PrimaryNetworkAssetType:
      type: string
      description: Type of asset like SECP256K1 or NFT.
      enum:
        - secp256k1
        - nft
    PrimaryNetworkAssetCap:
      type: string
      description: Cap represents if an asset is a variable or fixed cap asset.
      enum:
        - fixed
        - variable
  securitySchemes:
    apiKey:
      type: apiKey
      in: header
      name: x-glacier-api-key
      description: >-
        Api keys provide higher access to rate limits. To obtain an api key,
        sign up for an account at https://avacloud.io/.

````